package com.Game;

import android.graphics.drawable.Drawable;

import com.Game.Object;
import com.Game.Vector2D;

class GameBullet extends Object
{
	public GameBullet(Drawable drawable, Vector2D position, int width, int height)
	{
		mImage 				= drawable;		
		mDimention			= new Vector2D(mImage.getIntrinsicWidth(), mImage.getIntrinsicHeight());
		mDimentionHalf		= new Vector2D(mDimention.x / 2, mDimention.y / 2);
		mPosition			= new Vector2D(position.x, position.y - mDimentionHalf.y);
		
		mScreenWidth 		= width;
		mScreenHeight 		= height;
		mScreenWidthHalf 	= width / 2;
		mScreenHeightHalf 	= height / 2;
		mScreenWidthQuater 	= width / 4;
		mScreenHeightQuater = height / 4;
	}
	
	public boolean onBulletFired(boolean isBulletFired)
	{
		if(isBulletFired)
		{
			isBulletFired = false;
			if(!this.bIsAlive)
				this.bIsAlive = true;;
		}
		
		return isBulletFired;
	}
	
	public void onBulletDead(GamePlayer player)
	{
		mPosition.x = player.mPosition.x;
		mPosition.y = player.mPosition.y + mDimention.y;		
		
		bIsAlive = false;
	}
	
	public void GameLoop(int fallSpeed, GamePlayer player, boolean isBulletFired)
	{
		if(this.bIsAlive && isBulletFired)
			this.Fly(fallSpeed);
		else
			onBulletDead(player);
	}
}