package com.Game;

import android.graphics.drawable.Drawable;

import com.Game.Object;
import com.Game.Vector2D;

class GameEnemy extends Object
{
	public int			mNextSpawnY;
	public int			mBulletShootRange;
	public boolean		bCanJump;
	public boolean		bBulletReady;
	
	public GameEnemy(Drawable drawable, Vector2D position, int nextSpawnY, int width, int height)
	{
		mImage 				= drawable;
		mDimention			= new Vector2D(mImage.getIntrinsicWidth(), mImage.getIntrinsicHeight());
		mDimentionHalf		= new Vector2D(mDimention.x / 2, mDimention.y / 2);		
		mPosition			= new Vector2D(position.x, position.y - mDimention.x);
		
		mBulletShootRange	= 0;
		mNextSpawnY 		= nextSpawnY;		
		bCanJump 			= false;
		bBulletReady		= false;
		
		mScreenWidth 		= width;
		mScreenHeight 		= height;
		mScreenWidthHalf 	= mScreenWidth / 2;
		mScreenHeightHalf 	= mScreenHeight / 2;
		mScreenWidthQuater 	= mScreenWidth / 4;
		mScreenHeightQuater = mScreenHeight / 4;
	}
	
	//collide with bullet
	public void onColliding(Object bullet)
	{
		this.bIsAlive = false;
		bullet.bIsAlive = false;
	}
	
	//collide with player
	public void onColliding(Object player, int damage)
	{
		if(this.mPosition.y > mScreenHeight)
			player.mHealth -= damage;
		else
		{
			player.mScore += damage;
			player.mHealth -= damage;
		}
		
		this.bIsAlive = false;
		
		if(!this.bIsAlive)
			mPosition = new Vector2D(0, mScreenHeight * 2);
	}
	
	public void GameLoop(int fallSpeed)
	{
		if(this.bCanJump && this.bIsAlive)
			this.Fly(-fallSpeed);			
	}
}