package com.Game;

import android.graphics.drawable.Drawable;

import com.Game.Object;
import com.Game.Vector2D;

class GamePlayer extends Object
{
	public int 		mLivesLeft;	
	public boolean 	bBulletFired;
	
	public GamePlayer(Drawable drawable, Vector2D position, int maxLife, int width, int height)
	{
		mImage 				= drawable;
		mScore 				= 0;
		mLivesLeft 			= maxLife;	
		mPosition			= new Vector2D(position);
		mDimention			= new Vector2D(mImage.getIntrinsicWidth(), mImage.getIntrinsicHeight());
		mDimentionHalf		= new Vector2D(mDimention.x / 2, mDimention.y / 2);
		
		bBulletFired		= false;
		
		mScreenWidth 		= width;
		mScreenHeight 		= height;
		mScreenWidthHalf 	= mScreenWidth / 2;
		mScreenHeightHalf 	= mScreenHeight / 2;
		mScreenWidthQuater 	= mScreenWidth / 4;
		mScreenHeightQuater = mScreenHeight / 4;
	}
	
	public boolean ToggleBulletFired()
	{
		return !bBulletFired;
	}
	
	public void Move(int moveSpeed, Vector2D touchPos)
	{
		if(touchPos.x < mScreenWidthHalf && (mPosition.x - mDimentionHalf.x) > 0)
			this.Move(-moveSpeed);
				
		if(touchPos.x > mScreenWidthHalf && (mPosition.x + mDimentionHalf.x) < mScreenWidth)
			this.Move(moveSpeed);		
	}
	
	public void GameLoop(Vector2D touchPos, int moveSpeed)
	{
		Move(moveSpeed, touchPos);
			
		if(IsCollidingWith(touchPos.x, touchPos.y))
			bBulletFired = true;
	}
}