package com.Game;

import android.view.SurfaceHolder;
import android.graphics.Canvas;

public class GameThread extends Thread
{
	private SurfaceHolder mSurfaceHolder;
	private GameView mGameView;
	
	private int mCanvasWidth;
	private int mCanvasHeight;
	
	private boolean bRun = false;
		
	//Constructor	
	public GameThread(SurfaceHolder surfaceHolder, GameView gameView)
	{
		mSurfaceHolder = surfaceHolder;
		mGameView = gameView;
	}
	
	//Methods
	public SurfaceHolder getSurfaceHolder()
	{
		return mSurfaceHolder;
	}
	
	public void setRunning(boolean run)
	{
		bRun = run;
	}
	
	public void setSurfaceSize(int width, int height)
	{
		synchronized(mSurfaceHolder) {
			mCanvasWidth = width;
			mCanvasHeight = height;
		}
	}
	
	public int getCanvasWidth() { return mCanvasWidth; }
	public int getCanvasHeight() { return mCanvasHeight; }
	
	@Override
	public void run()
	{
		Canvas c;
		while(bRun)
		{
			c = null;
			try
			{
				c = mSurfaceHolder.lockCanvas(null);
				synchronized(mSurfaceHolder)
				{
					mGameView.gameLoop(c);
				}
			} finally
			{
				if(c != null)
				{
					mSurfaceHolder.unlockCanvasAndPost(c);
				}
			}
		}
	}
}