package com.Game;

import android.graphics.drawable.Drawable;
import android.graphics.Canvas;

import com.Game.Vector2D;

class Object
{
	public Drawable 	mImage;
	public Vector2D 	mPosition;
	public Vector2D 	mDimention;
	public Vector2D 	mDimentionHalf;
	public boolean		bIsAlive;
	public int			mHealth;
	public int 			mScore;
	
	public final int 	HEALTH_MAX		=	100;
	
	public int			mScreenWidth;
	public int			mScreenHeight;
	public int			mScreenWidthHalf;
	public int			mScreenHeightHalf;
	public int			mScreenWidthQuater;
	public int			mScreenHeightQuater;
	
	public Object()
	{
		bIsAlive	= false;
		mScore		= 0;
		mHealth 	= HEALTH_MAX;
	}
	
	public Vector2D GetPosition()
	{
		return mPosition;
	}
	
	public void SetPosition(Vector2D position)
	{
		mPosition = position;
	}
	
	public void SetPosition(int xx, int yy)
	{
		mPosition.SetVector(xx, yy);
	}
	
	public Vector2D GetDimention()
	{
		return mDimention;
	}
	
	public void Move(int moveSpeed)
	{			
		mPosition.x += moveSpeed;
	}
	
	public void Fly(int flySpeed)
	{
		mPosition.y -= flySpeed;
	}
	
	//Die!
	public void ApplyDamage()
	{
		ApplyDamage(mHealth);
	}
	
	public void ApplyDamage(int damage)
	{
		mHealth -= damage;
		if(mHealth <= 0)
		{
			mHealth = 0;
			bIsAlive = false;			
		}
	}
	
	public boolean IsCollidingWith(int x, int y)
	{
		Vector2D pos = new Vector2D(x, y);
		return this.IsCollidingWith(pos);
	}
	
	public boolean IsCollidingWith(Vector2D pos)
	{
		if(pos.x > this.mPosition.x && pos.x < this.mPosition.x + this.mDimention.x && 
			pos.y > this.mPosition.y && pos.y < this.mPosition.y + this.mDimention.y)
			return true;
		return false;
	}
	
	public boolean IsCollidingWith(Object object)
	{
		if(	this.mPosition.x > object.mPosition.x && this.mPosition.x < object.mPosition.x + object.mDimention.x && 
			this.mPosition.y > object.mPosition.y && this.mPosition.y < object.mPosition.y + object.mDimention.y || 
			object.mPosition.x > this.mPosition.x && object.mPosition.x < this.mPosition.x + this.mDimention.x && 
			object.mPosition.y > this.mPosition.y && object.mPosition.y < this.mPosition.y + this.mDimention.y )
				return true;
		return false;
	}
	
	public void RelocateTo(Object object, Vector2D offset)
	{
		this.mPosition.x = object.mPosition.x + offset.x;
		this.mPosition.y = object.mPosition.y + offset.y;
	}
	
	public void DrawSprite(Canvas c)
	{
		int xx = mPosition.x - mDimentionHalf.x;
		int yy = mPosition.y - mDimentionHalf.y;

		mImage.setBounds(xx, yy, (xx + mDimention.x), (yy + mDimention.y));
		mImage.draw(c);
	}
}